DECLARE SUB gcopy ()
DECLARE SUB pltspt (x!(), y!(), n%, iscale%)
DECLARE SUB hull (x!(), y!(), h!(), quo!(), n%)
DECLARE SUB getmin (h!(), quo!(), y!(), n%, idep%(), id%)
DECLARE SUB pltabs (quo!(), x!(), idep%(), id%)
DECLARE SUB loctxt (x!, y!)
DECLARE SUB pltfrm (sname$, sno$, comm$, iscale%)
DECLARE SUB getspt (sname$, x!(), y!(), n%, wmin!, wmax!, sno$, comm$)
DECLARE SUB getmax (y!(), n%, ymax!)
DECLARE SUB title ()
DECLARE SUB sel (rno%, i%)
DECLARE SUB rdatr (i%)
DECLARE SUB setloc (mode%)
DECLARE SUB atrprt (i%)
COMMON SHARED cnt$, dath$, datt$, viewx, viewy, windx, windy, windx1, windx2
'$INCLUDE: 'a:\bin\qb.bi'
no% = 120
mno% = 10
cnt$ = "b:pcspec.cnt"
dath$ = "b:"
datt$ = ".ref"
viewx = 639
viewy = 399
windx1 = 3
windy1 = 1
windx = 30
windy = 20
REM $DYNAMIC
DIM SHARED sid(no%) AS STRING * 20, name$(no%), color$(no%), sdate(no%) AS STRING * 10, nation$(no%)
DIM SHARED pref$(no%), site$(no%), latd%(no%), latm(no%), lond%(no%)
DIM SHARED lonm(no%), shape$(no%), alt$(no%)
DIM SHARED lid$(no%), lsid(no%) AS STRING * 12, ldate(no%) AS STRING * 10, lequ(no%) AS STRING * 12, lref$(no%)
DIM SHARED lprm$(no%), ltre$(no%), lamp$(no%)
DIM SHARED cid$(no%), csid(no%) AS STRING * 12, cdate(no%) AS STRING * 10, cequ(no%) AS STRING * 12, cprm$(no%)
DIM SHARED sio2(no%) AS SINGLE, tio2(no%), al2o3(no%), fe2o3(no%), feo(no%)
DIM SHARED mno(no%), mgo(no%), cao(no%), na2o(no%), k2o(no%), p2o5(no%)
DIM SHARED s(no%), c(no%), zro2(no%), h2op(no%), h2om(no%), co2(no%)
DIM SHARED so3(no%), loi(no%), bao(no%)
DIM SHARED nsid(no%) AS STRING * 12, ncid$(no%), q(no%), co(no%), ad(no%), mi(no%)
DIM SHARED ab(no%), an(no%), ka(no%), se(no%), ch(no%), gi(no%)
DIM SHARED mo(no%), pp(no%), dp(no%), al(no%), z(no%), hl(no%), th(no%)
DIM SHARED cc(no%), mg(no%), sd(no%), li(no%), mt(no%), he(no%)
DIM SHARED cm(no%), pr(no%), il(no%), ru(no%), ap(no%), fr(no%)
DIM SHARED en(no%), ot(no%), cond$(no%), com$(no%)
DIM SHARED xid$(no%), xsid(no%) AS STRING * 12, xdate(no%) AS STRING * 10, xequ(no%) AS STRING * 12, xprm$(no%)
DIM SHARED xtre$(no%)
DIM SHARED xxid$(no%), xmin(no%, mno%) AS STRING * 20, xmno%(no%)
DIM SHARED wvl(1151), igrt%(9)
DIM x(1151), y(1151), h(800), quo(800), idep%(400)
REM $STATIC
OPEN cnt$ FOR INPUT AS #1
i% = 1
j% = 1
CALL rdatr(i%)
xmno%(i%) = 1
CLS
CALL title
DO WHILE NOT EOF(1) AND i% < no%
	LOCATE 23, 1
	PRINT " Reading control file ---"; i%
	i% = i% + 1
	CALL rdatr(i%)
	IF sid$(i%) = sid$(i% - 1) THEN
		xmno%(i% - 1) = xmno%(i% - 1) + 1
		xmin$(i% - 1, xmno%(i% - 1)) = xmin$(i%, 1)
		i% = i% - 1
	ELSE
		xmno%(i%) = 1
	END IF
LOOP
CLOSE #1
rno% = i%
INPUT "Remove Control Disk and insert Data Disk to drive B:", a$
DO
	SCREEN 0
	CALL sel(rno%, i%)
	IF i% <= 0 THEN EXIT DO
	CALL atrprt(i%)
	CALL getspt(lid$(i%), x(), y(), n%, .5, 2.6, sno$, comm$)
	CALL getmax(y(), n%, ymax)
	IF ymax > 60! THEN
		iscale% = 1
	ELSE
		iscale% = 2
	END IF
	SCREEN 87
	VIEW (0, 0)-(viewx, viewy)
	WINDOW (windx1, windy1)-(windx1 + windx, windy1 + windy)
	CALL pltfrm(lid$(i%), sid$(i%), comm$, iscale%)
	CALL pltspt(x(), y(), n%, iscale%)
	CALL hull(x(), y(), h(), quo(), n%)
	CALL pltspt(x(), h(), n%, iscale%)
	CALL getmin(h(), quo(), y(), n%, idep%(), id%)
	CALL pltabs(quo(), x(), idep%(), id%)
	LOCATE 24, 1
	INPUT " *** Hit enter key to continue or P to hardcopy print *** "; a$
	IF a$ = "p" OR a$ = "P" THEN CALL gcopy
LOOP UNTIL i% <= 0

SUB atrprt (i%)
CALL setloc(0): PRINT "Sample record"
CALL setloc(1): PRINT USING "@"; "  Sample ID      "; sid$(i%)
CALL setloc(1): PRINT USING "@"; "  Sample name    "; name$(i%)
CALL setloc(1): PRINT USING "@"; "  Color          "; color$(i%)
CALL setloc(1): PRINT USING "@"; "  Sampling date  "; sdate$(i%)
CALL setloc(1): PRINT USING "@"; "  Nation         "; nation$(i%)
CALL setloc(1): PRINT USING "@"; "  Prefecture     "; pref$(i%)
CALL setloc(1): PRINT USING "@"; "  Locality       "; site$(i%)
IF latd%(i%) > 0 AND latm(i%) > 0 THEN CALL setloc(1): PRINT USING "@### ###.##"; "  Latitude       "; latd%(i%); latm(i%)
IF lond%(i%) > 0 AND lonm(i%) > 0 THEN CALL setloc(1): PRINT USING "@### ###.##"; "  Longitude      "; lond%(i%); lonm(i%)
CALL setloc(1): PRINT USING "@"; "  Sample shape   "; shape$(i%)
CALL setloc(1): PRINT USING "@"; "  Alteration     "; alt$(i%)
CALL setloc(2): PRINT "Lab. measurement record"
CALL setloc(1): PRINT USING "@"; "  Measurement ID "; lid$(i%)
CALL setloc(1): PRINT USING "@"; "  Sample ID      "; lsid$(i%)
CALL setloc(1): PRINT USING "@"; "  Date           "; ldate$(i%)
CALL setloc(1): PRINT USING "@"; "  Equipment      "; lequ$(i%)
CALL setloc(1): PRINT USING "@"; "  Reference      "; lref$(i%)
CALL setloc(1): PRINT USING "@"; "  Parameter      "; lprm$(i%)
CALL setloc(1): PRINT USING "@"; "  Treatment      "; ltre$(i%)
CALL setloc(1): PRINT USING "@"; "  Lamp           "; lamp$(i%)
CALL setloc(2): PRINT "Chemical composition record"
CALL setloc(1): PRINT USING "@"; "  Measurement ID "; cid$(i%)
CALL setloc(1): PRINT USING "@"; "  Sample ID      "; csid$(i%)
CALL setloc(1): PRINT USING "@"; "  Date           "; cdate$(i%)
CALL setloc(1): PRINT USING "@"; "  Equipment      "; cequ$(i%)
CALL setloc(1): PRINT USING "@"; "  Parameter      "; cprm$(i%)
IF sio2(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  SiO2           "; sio2(i%)
IF tio2(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  TiO2           "; tio2(i%)
IF al2o3(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Al2O3          "; al2o3(i%)
IF fe2o3(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Fe2O3          "; fe2o3(i%)
IF mgo(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  MgO            "; mgo(i%)
IF cao(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  CaO            "; cao(i%)
IF na2o(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Na2O           "; na2o(i%)
IF k2o(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  K2O            "; k2o(i%)
IF p2o5(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  P2O5           "; p2o5(i%)
IF bao(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  BaO            "; bao(i%)
IF loi(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  LOI            "; loi(i%)
CALL setloc(1): PRINT USING "@###.##"; "  Total          "; sio2(i%) + tio2(i%) + al2o3(i%) + fe2o3(i%) + mgo(i%) + cao(i%) + na2o(i%) + k2o(i%) + p2o5(i%) + bao(i%) + loi(i%)
IF feo(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  FeO            "; feo(i%)
IF s(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  S              "; s(i%)
IF h2op(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  H2O+           "; h2op(i%)
IF h2om(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  H2O-           "; h2om(i%)
CALL setloc(2): PRINT "Mineral composition record"
CALL setloc(1): PRINT USING "@"; "  Sample ID      "; nsid$(i%)
CALL setloc(1): PRINT USING "@"; "  Chemical Rec.  "; ncid$(i%)
IF q(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Quartz         "; q(i%)
IF co(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Corumdum       "; co(i%)
IF ad(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Andalusite     "; ad(i%)
IF mi(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Microcline     "; mi(i%)
IF ab(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Albite         "; ab(i%)
IF an(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Anorthite      "; an(i%)
IF ka(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Kaolinite      "; ka(i%)
IF se(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Sericite       "; se(i%)
IF ch(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Chlorite       "; ch(i%)
IF gi(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Gibbsite       "; gi(i%)
IF mo(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Montmorillonite"; mo(i%)
IF pp(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Pyrophyllite   "; pp(i%)
IF dp(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Diaspore       "; dp(i%)
IF al(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Alunite        "; al(i%)
IF z(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Zircon         "; z(i%)
IF hl(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Halite         "; hl(i%)
IF th(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Thernardite    "; th(i%)
IF cc(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Calcite        "; cc(i%)
IF mg(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Magnesite      "; mg(i%)
IF sd(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Siderite       "; sd(i%)
IF li(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Limonite       "; li(i%)
IF mt(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Magnetite      "; mt(i%)
IF he(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Hematite       "; he(i%)
IF cm(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Chromite       "; cm(i%)
IF pr(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Pyrite         "; pr(i%)
IF il(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Ilmenite       "; il(i%)
IF ru(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Rutile         "; ru(i%)
IF ap(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Apatite        "; ap(i%)
IF fr(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Fluorite       "; fr(i%)
IF en(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Enstatite      "; en(i%)
IF ot(i%) > 0 THEN CALL setloc(1): PRINT USING "@###.##"; "  Others         "; ot(i%)
total = q(i%) + co(i%) + co(i%) + ad(i%) + mi(i%) + ab(i%)
total = total + an(i%) + ka(i%) + se(i%) + ch(i%) + gi(i%) + mo(i%) + pp(i%)
total = total + al(i%) + z(i%) + hl(i%) + cc(i%) + mg(i%)
total = total + sd(i%) + li(i%) + mt(i%) + he(i%) + cm(i%)
total = total + pr(i%) + il(i%) + ru(i%) + ap(i%) + fr(i%) + en(i%) + ot(i%)
CALL setloc(1): PRINT USING "@###.##"; "  Total          "; total
CALL setloc(1): PRINT USING "@"; "  Condition      "; cond$(i%)
CALL setloc(1): PRINT USING "@"; "  Comment        "; com$(i%)
CALL setloc(2): PRINT "Xray measurement record"
CALL setloc(1): PRINT USING "@"; "  Measurement ID "; xid$(i%)
CALL setloc(1): PRINT USING "@"; "  Sample ID      "; xsid$(i%)
CALL setloc(1): PRINT USING "@"; "  Date           "; xdate$(i%)
CALL setloc(1): PRINT USING "@"; "  Equipment      "; xequ$(i%)
CALL setloc(1): PRINT USING "@"; "  Parameter      "; xprm$(i%)
CALL setloc(1): PRINT USING "@"; "  Treatment      "; xtre$(i%)
CALL setloc(1): PRINT "  Detected minerals"
FOR j% = 1 TO xmno%(i%)
	CALL setloc(1): PRINT USING "@"; "                 "; xmin$(i%, j%)
NEXT j%
CALL setloc(-1)
END SUB

SUB gcopy
	DIM inreg AS RegType
	DIM outreg AS RegType
	DEF SEG = &HA800
	FOR x = 79 TO 0 STEP -1
		a$ = CHR$(&H1B) + "T" + "12" + CHR$(&H1B) + "D" + CHR$(&H1B) + "S" + "0400"
		FOR y = 0 TO 399
			d0% = PEEK(x + y * 80)
			a$ = a$ + CHR$(d0%)
		NEXT
		a$ = a$ + CHR$(&HD, &HA)
		inreg.ax = &H3000
		inreg.bx = SADD(a$)
		inreg.cx = LEN(a$)
		INTERRUPT &H1A, inreg, outreg
	NEXT
		a$ = CHR$(&HC) + CHR$(&H1B) + "A"
		inreg.ax = &H3000
		inreg.bx = SADD(a$)
		inreg.cx = LEN(a$)
		INTERRUPT &H1A, inreg, outreg
END SUB

SUB getmax (y(), n%, ymax)
ymax = y(1)
FOR i% = 2 TO n%
	IF y(i%) > ymax THEN ymax = y(i%)
NEXT i%
END SUB

SUB getmin (h(), quo(), y(), n%, idep%(), id%)
idis% = 3
th = 2
j! = 0
FOR i% = idis% + 1 TO n% - idis% - 1
	depth = h(i%) - y(i%)
	IF y(i%) < y(i% - 3) AND y(i%) < y(i% + 3) AND y(i%) < y(i% - 2) AND y(i%) < y(i% + 2) AND y(i%) < y(i% - 1) AND y(i%) < y(i% + 1) AND depth > th THEN
		j% = j% + 1
		idep%(j%) = i%
	END IF
NEXT i%
id% = j%
FOR i% = 1 TO id% - 1
	FOR j% = i% + 1 TO id%
		id1% = idep%(i%)
		id2% = idep%(j%)
		IF quo(id2%) < quo(id1%) THEN
			idep%(i%) = id2%
			idep%(j%) = id1%
		END IF
	NEXT j%
NEXT i%
END SUB

SUB getspt (sname$, x(), y(), n%, wmin, wmax, sno$, comm$)
STATIC wname$
OPEN dath$ + sname$ + datt$ FOR INPUT AS #1
LINE INPUT #1, a$
INPUT #1, B$
FOR i% = 1 TO 1151: INPUT #1, y(i%): NEXT i%
LINE INPUT #1, a$
sno$ = MID$(a$, 1, 18)
comm$ = MID$(a$, 19, 60)
CLOSE #1
IF wname$ <> B$ THEN
	wname$ = B$
	OPEN dath$ + wname$ FOR INPUT AS #1
	LINE INPUT #1, a$
	FOR i% = 1 TO 1151: INPUT #1, wvl(i%): wvl(i%) = wvl(i%) / 10000: NEXT i%
	FOR i% = 1 TO 8: INPUT #1, igrt%(i%): NEXT i%
	CLOSE #1
	igrt%(9) = 800
END IF
	n1s = 1
	n1e = igrt%(2)
	n2s = igrt%(4)
	n2e = igrt%(6)
	n3s = igrt%(8)
	n3e = igrt%(9)
	j% = 1
	FOR i% = n1s TO n1e
		IF wvl(i%) > wmin AND wvl(i%) < wmax THEN
			x(j%) = wvl(i%)
			y(j%) = y(i%)
			j% = j% + 1
		END IF
	NEXT i%
	FOR i% = n2s TO n2e
		IF wvl(i%) > wmin AND wvl(i%) < wmax THEN
			x(j%) = wvl(i%)
			y(j%) = y(i%)
			j% = j% + 1
		END IF
	NEXT i%
	FOR i% = n3s TO n3e
		IF wvl(i%) > wmin AND wvl(i%) < wmax THEN
			x(j%) = wvl(i%)
			y(j%) = y(i%)
			j% = j% + 1
		END IF
	NEXT i%
	n% = j% - 1
	FOR i% = 1 TO n%
		IF y(i%) > 150 THEN y(i%) = 150
		IF y(i%) < 0 THEN y(i%) = 0
	NEXT i%
END SUB

SUB hull (x(), y(), h(), quo(), n%)
i% = 1
DO WHILE i% < n%
	angmax = -100000!
	FOR j% = i% + 1 TO n%
		ang = (y(j%) - y(i%)) / (x(j%) - x(i%))
		IF ang > angmax THEN
			angmax = ang
			jmax% = j%
			END IF
	NEXT j%
	FOR j% = i% TO jmax%
		h(j%) = angmax * (x(j%) - x(i%)) + y(i%)
		quo(j%) = y(j%) * 100 / h(j%)
	NEXT j%
	i% = jmax%
LOOP
END SUB

SUB loctxt (x, y)
xx = (x - windx1) / windx * viewx
yy = (1 - (y - windy1) / windy) * viewy
col = xx / 640 * 80
row = yy / 400 * 25 + 1
IF col < 1 THEN col = 1
IF col > 80 THEN col = 80
IF row < 0 THEN row = 1
IF row > 24 THEN row = 24
LOCATE row, col
END SUB

SUB pltabs (quo(), x(), idep%(), id%)
x2 = 5
y2 = 16.5
xl2 = 15
yl2 = 2
x3 = 25
y3 = 19
dy3 = -.8
IF (id% < 1) THEN EXIT SUB
CALL loctxt(x3, y3 + .5): PRINT "Absorption"
CALL loctxt(x3, y3 + .5 + dy3): PRINT "no.  wvl.  abs."
FOR i% = 1 TO id%
	ii% = idep%(i%)
	xx = x(ii%) * xl2 / 3 + x2
	yy = y2
	LINE (xx, yy)-STEP(0!, (100 - quo(ii%)) * yl2 / 100)
	IF i% < 21 THEN
		CALL loctxt(x3, y3 + .5 + (i% + 1) * dy3)
		PRINT USING "## #.### ###.#"; i%; x(ii%); 100 - quo(ii%)
	END IF
NEXT i%
END SUB

SUB pltfrm (sname$, sno$, comm$, iscale%)
CLS
x1 = 5
y1 = 3.5
xl1 = 15
yl1 = 12
x2 = 5
y2 = 16.5
xl2 = 15
yl2 = 2
LINE (x1, y1)-STEP(xl1, yl1), , B
LINE (x2, y2)-STEP(xl2, yl2), , B
FOR i% = 1 TO 6
	x = x1 + i% * xl1 / 6
	y = y1: LINE (x, y)-STEP(0!, .2)
	y = y1 + yl1: LINE (x, y)-STEP(0!, -.2)
	wvl = i% / 2
	CALL loctxt(x - .5, y)
	PRINT USING "#.#"; wvl
NEXT i%
FOR i% = 0 TO 12 STEP 2
	y = y1 + i% * yl1 / 12
	x = x1: LINE (x, y)-STEP(.2, 0!)
	x = x1 + xl1: LINE (x, y)-STEP(-.2, 0!)
	ref = i% * 10 / iscale%
	x = x1 - 1!
	CALL loctxt(x, y - .1)
	PRINT USING "###"; ref
NEXT i%
FOR i% = 1 TO 6
	x = x2 + i% * xl2 / 6
'   y = y2 + .1: LINE (x, y)-STEP(0!, .1)
	y = y2 + yl2: LINE (x, y)-STEP(0!, -.2)
	wvl = i% / 2
	y = y2 - .4
	CALL loctxt(x - .5, y)
'   PRINT USING "#.#"; wvl
NEXT i%
FOR i% = 0 TO 2
	y = y2 + i% * yl2 / 2
	x = x2: LINE (x, y)-STEP(.2, 0!)
	x = x2 + xl2: LINE (x, y)-STEP(-.2, 0!)
	ref = i% * 50
	x = x2 - 1!
	CALL loctxt(x, y - .8)
	PRINT USING "###"; ref
NEXT i%
CALL loctxt(x1 + xl1 / 4, y1 - 1.2): PRINT "Wave length (micro meter)"
CALL loctxt(x2, y2 + yl2 + .6): PRINT USING "@@"; "Sample no. : "; sno$
CALL loctxt(x2 + xl2 / 2 + 1!, y2 + yl2 + .6): PRINT USING "@@"; "Measurement no. : "; sname$
CALL loctxt(x2, y2 + yl2 + .1): PRINT USING "@@"; "Comment : "; comm$
END SUB

SUB pltspt (x(), y(), n%, iscale%)
x1 = 5
y1 = 3.5
xl1 = 15
yl1 = 12
PSET (x(1) * xl1 / 3 + x1, y(1) * yl1 * iscale% / 120 + y1)
FOR i% = 2 TO n%
	LINE -(x(i%) * xl1 / 3 + x1, y(i%) * yl1 * iscale% / 120 + y1)
NEXT i%
END SUB

SUB rdatr (i%)
INPUT #1, sid$(i%), name$(i%), color$(i%), sdate$(i%), nation$(i%)
INPUT #1, pref$(i%), site$(i%), latd%(i%), latm(i%), lond%(i%)
INPUT #1, lonm(i%), shape$(i%), alt$(i%)
INPUT #1, lid$(i%), lsid$(i%), ldate$(i%), lequ$(i%), lref$(i%)
INPUT #1, lprm$(i%), ltre$(i%), lamp$(i%)
INPUT #1, csid$(i%), cid$(i%), cdate$(i%), cequ$(i%), cprm$(i%)
INPUT #1, sio2(i%), tio2(i%), al2o3(i%), fe2o3(i%), feo(i%)
INPUT #1, mno(i%), mgo(i%), cao(i%), na2o(i%), k2o(i%), p2o5(i%)
INPUT #1, s(i%), c(i%), zro2(i%), h2op(i%), h2om(i%), co2(i%)
INPUT #1, so3(i%), loi(i%), bao(i%)
INPUT #1, nsid$(i%), ncid$(i%), q(i%), co(i%), ad(i%), mi(i%)
INPUT #1, ab(i%), an(i%), ka(i%), se(i%), ch(i%), gi(i%)
INPUT #1, mo(i%), pp(i%), dp(i%), al(i%), z(i%), hl(i%), th(i%)
INPUT #1, cc(i%), mg(i%), sd(i%), li(i%), mt(i%), he(i%)
INPUT #1, cm(i%), pr(i%), il(i%), ru(i%), ap(i%), fr(i%)
INPUT #1, en(i%), ot(i%), cond$(i%), com$(i%)
INPUT #1, xsid$(i%), xid$(i%), xdate$(i%), xequ$(i%), xprm$(i%)
INPUT #1, xtre$(i%)
INPUT #1, xxid$(i%), xmin$(i%, 1)
END SUB

SUB sel (rno%, i%)
i% = 0
DO
	CLS
	FOR j% = 1 TO rno%
		PRINT USING "### &            & "; j%; sid$(j%);
		IF j% - INT(j% / 4) * 4 = 0 THEN PRINT
		IF j% - INT(j% / 88) * 88 = 0 THEN
			INPUT " *** Select number to display or enter key to next page or -1 to quit *** ", i%
			IF i% > 0 AND i% <= rno% THEN EXIT SUB
			IF i% = -1 THEN EXIT SUB
			CLS
		END IF
	NEXT j%
	PRINT
	INPUT " *** Select number to display or -1 to quit *** ", i%
LOOP UNTIL i% > 0 AND i% <= rno% OR i% = -1
END SUB

SUB setloc (mode%)
STATIC row%, col%
CONST maxrow = 24
CONST maxcol = 80
CONST dcol = 39
IF mode% = 0 THEN
	row% = 1
	col% = 1
	CLS
ELSE
	IF mode% > 0 THEN
		row% = row% + mode%
		IF row% > maxrow - 1 THEN
			row% = 1
			col% = col% + dcol
			IF col% > maxcol - dcol THEN
				col% = 1
				LOCATE maxrow, 1
				INPUT " *** Hit enter key to continue ***", a$
				CLS
			END IF
		END IF
	ELSE
		LOCATE maxrow, 1
		INPUT " *** Hit enter key to continue ***", a$
	END IF
END IF
LOCATE row%, col%
END SUB

SUB title
PRINT "**************************************************************************"
PRINT "*   PCSPEC --- Spectra display software for                              *"
PRINT "*      rocks and minerals on pasonal computer                            *"
PRINT "*                                                                        *"
PRINT "*   Please refer:                                                        *"
PRINT "*     Reflectance spectra catalog of rocks and minerals                  *"
PRINT "*       in the visible to short-wave-infrared region                     *"
PRINT "*                                                                        *"
PRINT "* M. Urai, I. Sato, Y. Ninomiya, R. Kouda, Y. Miyazaki AND Y. Yamaguchi  *"
PRINT "*                                      Geological Survey of Japan, 1989. *"
PRINT "*                                                                        *"
PRINT "*                            Copyright Geological Survey of Japan, 1989. *"
PRINT "**************************************************************************"
PRINT
PRINT
END SUB

